//////////////////////////////////////////////////////////////
// ADC interface code for PIC18F devices
//
// (c)Martin Hug 2012.
/////////////////////////////////////////////////////////////

#include "adc_ng.h"
#include "system.h"
#include "nrf24L01.h"
#include "spi.h"
#include "global.h"
#include <PIC18f4420.h>


unsigned char upper_lower[4];
short Vel_Data, Data_PAD, ad_h_aux;


unsigned char scan_analog(char analog_ch){

  char AN_IN = analog_ch;
	char address = 0;

   select_analog(AN_IN);    
 
       
        Go_Done = 1;
        while (Go_Done != 0);

			
				if (AN_IN == 0 ){														// depends where the sensor is plugged in.
			 	
   	    	ad_h_aux = ad_h << 8;
  	    	Vel_Data = ad_h_aux | ad_l;

					if ((Vel_Data > 0x07) && (!pad_flag_0)){	// if 0x05 true.
					Data_PAD = evaluate_pad(Vel_Data, AN_IN);	// evaluate hit.
					}

					if (Vel_Data <= 0x03){										// TH value.
					off_flag_0 = false;												// allows data send,
					pad_flag_0 = false;												// but only if value is >0x05.
					}	
				}

				if (AN_IN == 1 ){														// depends where the sensor is plugged in.
			 	
   	    	ad_h_aux = ad_h << 8;
  	    	Vel_Data = ad_h_aux | ad_l;

					if ((Vel_Data > 0x07) && (!pad_flag_1)){	// if 0x05 true.
					Data_PAD = evaluate_pad(Vel_Data, AN_IN);	// evaluate hit.
					}

					if (Vel_Data <= 0x03){										// TH value.
					off_flag_1 = false;												// allows data send,
					pad_flag_1 = false;												// but only if value is >0x05.
					}	
				}


				// version con payload 4.
        upper_lower[0] = 0x00;                  		// DEBUG test: Init byte = 0x00.
				upper_lower[1] = address;
        upper_lower[2] = Data_PAD;
	      upper_lower[3] = Data_PAD  >> 8;

	           
        if (AN_IN == 0)
        upper_lower[1] = address | 0x00; // AN 0; 00'00b  = 00 (RA0).
        if (AN_IN == 1)
        upper_lower[1] = address | 0x01; // AN 1; 01'00b  = 04 (RA1).
        if (AN_IN == 2)
        upper_lower[1] = address | 0x02; // AN 2; 10'00b  = 08 (RA2).
        if (AN_IN == 3) 
        upper_lower[1] = address | 0x03; // AN 3; 11'00b  = 12 (RA3).
        if (AN_IN == 4) 
        upper_lower[1] = address | 0x04; // AN 4; 100'00b = 16 (RA4).
        if (AN_IN == 5)
        upper_lower[1] = address | 0x05; // AN 5; 101'00b = 20 (RA5).
				if (AN_IN == 6)
        upper_lower[1] = address | 0x06; // AN 6; 110'00b = 24 (RA6).
				if (AN_IN == 7)
        upper_lower[1] = address | 0x07; // AN 7; 111'00b = 28 (RA7).
      
        analog_ch++;
         if (analog_ch == 2){                  			// set how may analog input to scan.
          analog_ch = 0;
          }
       
     return analog_ch;
}
//
//

short get_result(){
    short Sum, ad_h_aux, ad_l_aux;
    ad_l_aux = ad_l;
    ad_h_aux = ad_h << 8;
    Sum = ad_h_aux | ad_l_aux;
    return Sum;
}

//
//

unsigned char get_analog(char number){
    return upper_lower[number];
    }
//
//

void select_analog(char CH){

  switch (CH){
    case 0:
    adcon0 = 00000001b;                       // AN_0
    break;
    case 1: 
    adcon0 = 00000101b;                       // AN_1
    break;
    case 2:
    adcon0 = 00001001b;                       // AN_2
    break;
    case 3:
    adcon0 = 00001101b;                       // AN_3
    break;
    case 4:
    adcon0 = 00010001b;                       // AN_4
    break;
    case 5:
    adcon0 = 00010101b;                       // AN_5
    break;
    case 6:
    adcon0 = 00011001b;                       // AN_6
    break;
    case 7:
    adcon0 = 00011101b;                       // AN_7
    break;
  }
}
//
//






